// Arno Motion Add-On - DMP6 demo sketch
//use to send values to processing 'teapot'demo
//Olympia Circuits
// -----------------------------
//
// Based on MPU6050 sketch By arduino.cc user "Krodal" and Varesano(FreeIMU) cube demo
//http://www.varesano.net/blog/fabio/my-first-6-dof-imu-sensors-fusion-implementation-adxl345-itg3200-arduino-and-processing
//
// We modified make it more reliable with limitations of softi2c.  variable length reads were replaces with fixed length
// since this very specific in nature.

 
//softi2c addition
#define NO_INTERRUPT 1
#define I2C_TIMEOUT 1000

#define SDA_PORT PORTB
#define SDA_PIN 3
#define SCL_PORT PORTB
#define SCL_PIN 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)

#include <SoftI2CMaster.h>
#include <avr/io.h>


//---------

// variables added for Starter Sketch for Arno Motion
//
int accelRaw[3];
int gyroRaw[3];
int tempRaw;


char str[512];
// variables for teapot demo
// packet structure for InvenSense teapot demo
uint8_t teapotPacket[14] = { '$', 0x02, 0,0, 0,0, 0,0, 0,0, 0x00, 0x00, '\r', '\n' };


//-----test variables


#define MPU6050_AUX_VDDIO          0x01   // R/W
#define MPU6050_SMPLRT_DIV         0x19   // R/W
#define MPU6050_CONFIG             0x1A   // R/W
#define MPU6050_GYRO_CONFIG        0x1B   // R/W
#define MPU6050_ACCEL_CONFIG       0x1C   // R/W
#define MPU6050_FF_THR             0x1D   // R/W
#define MPU6050_FF_DUR             0x1E   // R/W
#define MPU6050_MOT_THR            0x1F   // R/W
#define MPU6050_MOT_DUR            0x20   // R/W
#define MPU6050_ZRMOT_THR          0x21   // R/W
#define MPU6050_ZRMOT_DUR          0x22   // R/W
#define MPU6050_FIFO_EN            0x23   // R/W
#define MPU6050_I2C_MST_CTRL       0x24   // R/W
#define MPU6050_I2C_SLV0_ADDR      0x25   // R/W
#define MPU6050_I2C_SLV0_REG       0x26   // R/W
#define MPU6050_I2C_SLV0_CTRL      0x27   // R/W
#define MPU6050_I2C_SLV1_ADDR      0x28   // R/W
#define MPU6050_I2C_SLV1_REG       0x29   // R/W
#define MPU6050_I2C_SLV1_CTRL      0x2A   // R/W
#define MPU6050_I2C_SLV2_ADDR      0x2B   // R/W
#define MPU6050_I2C_SLV2_REG       0x2C   // R/W
#define MPU6050_I2C_SLV2_CTRL      0x2D   // R/W
#define MPU6050_I2C_SLV3_ADDR      0x2E   // R/W
#define MPU6050_I2C_SLV3_REG       0x2F   // R/W
#define MPU6050_I2C_SLV3_CTRL      0x30   // R/W
#define MPU6050_I2C_SLV4_ADDR      0x31   // R/W
#define MPU6050_I2C_SLV4_REG       0x32   // R/W
#define MPU6050_I2C_SLV4_DO        0x33   // R/W
#define MPU6050_I2C_SLV4_CTRL      0x34   // R/W
#define MPU6050_I2C_SLV4_DI        0x35   // R  
#define MPU6050_I2C_MST_STATUS     0x36   // R
#define MPU6050_INT_PIN_CFG        0x37   // R/W
#define MPU6050_INT_ENABLE         0x38   // R/W
#define MPU6050_INT_STATUS         0x3A   // R  
#define MPU6050_ACCEL_XOUT_H       0x3B   // R  
#define MPU6050_ACCEL_XOUT_L       0x3C   // R  
#define MPU6050_ACCEL_YOUT_H       0x3D   // R  
#define MPU6050_ACCEL_YOUT_L       0x3E   // R  
#define MPU6050_ACCEL_ZOUT_H       0x3F   // R  
#define MPU6050_ACCEL_ZOUT_L       0x40   // R  
#define MPU6050_TEMP_OUT_H         0x41   // R  
#define MPU6050_TEMP_OUT_L         0x42   // R  
#define MPU6050_GYRO_XOUT_H        0x43   // R  
#define MPU6050_GYRO_XOUT_L        0x44   // R  
#define MPU6050_GYRO_YOUT_H        0x45   // R  
#define MPU6050_GYRO_YOUT_L        0x46   // R  
#define MPU6050_GYRO_ZOUT_H        0x47   // R  
#define MPU6050_GYRO_ZOUT_L        0x48   // R  
#define MPU6050_EXT_SENS_DATA_00   0x49   // R  
#define MPU6050_EXT_SENS_DATA_01   0x4A   // R  
#define MPU6050_EXT_SENS_DATA_02   0x4B   // R  
#define MPU6050_EXT_SENS_DATA_03   0x4C   // R  
#define MPU6050_EXT_SENS_DATA_04   0x4D   // R  
#define MPU6050_EXT_SENS_DATA_05   0x4E   // R  
#define MPU6050_EXT_SENS_DATA_06   0x4F   // R  
#define MPU6050_EXT_SENS_DATA_07   0x50   // R  
#define MPU6050_EXT_SENS_DATA_08   0x51   // R  
#define MPU6050_EXT_SENS_DATA_09   0x52   // R  
#define MPU6050_EXT_SENS_DATA_10   0x53   // R  
#define MPU6050_EXT_SENS_DATA_11   0x54   // R  
#define MPU6050_EXT_SENS_DATA_12   0x55   // R  
#define MPU6050_EXT_SENS_DATA_13   0x56   // R  
#define MPU6050_EXT_SENS_DATA_14   0x57   // R  
#define MPU6050_EXT_SENS_DATA_15   0x58   // R  
#define MPU6050_EXT_SENS_DATA_16   0x59   // R  
#define MPU6050_EXT_SENS_DATA_17   0x5A   // R  
#define MPU6050_EXT_SENS_DATA_18   0x5B   // R  
#define MPU6050_EXT_SENS_DATA_19   0x5C   // R  
#define MPU6050_EXT_SENS_DATA_20   0x5D   // R  
#define MPU6050_EXT_SENS_DATA_21   0x5E   // R  
#define MPU6050_EXT_SENS_DATA_22   0x5F   // R  
#define MPU6050_EXT_SENS_DATA_23   0x60   // R  
#define MPU6050_MOT_DETECT_STATUS  0x61   // R  
#define MPU6050_I2C_SLV0_DO        0x63   // R/W
#define MPU6050_I2C_SLV1_DO        0x64   // R/W
#define MPU6050_I2C_SLV2_DO        0x65   // R/W
#define MPU6050_I2C_SLV3_DO        0x66   // R/W
#define MPU6050_I2C_MST_DELAY_CTRL 0x67   // R/W
#define MPU6050_SIGNAL_PATH_RESET  0x68   // R/W
#define MPU6050_MOT_DETECT_CTRL    0x69   // R/W
#define MPU6050_USER_CTRL          0x6A   // R/W
#define MPU6050_PWR_MGMT_1         0x6B   // R/W
#define MPU6050_PWR_MGMT_2         0x6C   // R/W
#define MPU6050_FIFO_COUNTH        0x72   // R/W
#define MPU6050_FIFO_COUNTL        0x73   // R/W
#define MPU6050_FIFO_R_W           0x74   // R/W
#define MPU6050_WHO_AM_I           0x75   // R


// Defines for the bits, to be able to change 
// between bit number and binary definition.
// By using the bit number, programming the sensor 
// is like programming the AVR microcontroller.
// But instead of using "(1<<X)", or "_BV(X)", 
// the Arduino "bit(X)" is used.
#define MPU6050_D0 0
#define MPU6050_D1 1
#define MPU6050_D2 2
#define MPU6050_D3 3
#define MPU6050_D4 4
#define MPU6050_D5 5
#define MPU6050_D6 6
#define MPU6050_D7 7


// Default I2C address for the MPU-6050 is 0x68, this is the Arno Motion Address.
// 
#define MPU6050_I2C_ADDRESS 0xD0 //68


#include <SoftI2CMaster.h>
#include <avr/io.h>


void setup()
{      
  delay(3000);  //time to start serial monitor
  int error;
  uint8_t c;

  Serial.begin(9600);
  

  
  //from multiwii  set up 6050
  delay(100);
  MPU6050_write_one(0x6B, B10000000);             //PWR_MGMT_1    -- DEVICE_RESET 1
  delay(100);
   MPU6050_write_one(0x6B, 0);             //PWR_MGMT_1    -
  delay(100);
 
}


void loop()
{
  
  
  readRaw();
  sprintf(str, "%d,%d,%d,%d,%d,%d,%d", accelRaw[1], accelRaw[0], accelRaw[2], gyroRaw[1], gyroRaw[0], gyroRaw[2], tempRaw);  //send values via serial to Processing on computer
  Serial.print(str);
  Serial.write(10);
  
  delay(50); //send values every 50 milliseconds

 
}



//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//-----------------------Read Raw Values---------------------
// Function to read raw accelerometer and Gyro values
// Values will be placed in arrays 0=x, 1=y, 2=z
// Use global variables accelRaw and gyroRaw
//Read accel values
//call readtwo with accel xout high address and then y, z

void readRaw(){
  //Serial.println("into readrawvalues");
accelRaw[0]= MPU6050_read_two (MPU6050_ACCEL_XOUT_H);
accelRaw[1]= MPU6050_read_two (MPU6050_ACCEL_YOUT_H);
accelRaw[2]= MPU6050_read_two (MPU6050_ACCEL_ZOUT_H);

//call readtwo with gyro addresses
gyroRaw[0] = MPU6050_read_two (MPU6050_GYRO_XOUT_H);
gyroRaw[1] = MPU6050_read_two (MPU6050_GYRO_YOUT_H);
gyroRaw[2] = MPU6050_read_two (MPU6050_GYRO_ZOUT_H);

//call readtwo with temperature address
tempRaw = MPU6050_read_two  (MPU6050_TEMP_OUT_H);


}
///<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

// --------------------------------------------------------
// MPU6050_read
//
// This is a common function to read multiple bytes 
// from an I2C device.
//
// It uses the boolean parameter for Wire.endTransMission()
// to be able to hold or release the I2C-bus. 
// This is implemented in Arduino 1.0.1.
//
// Only this function is used to read. 
// There is no function for a single byte.
//
int MPU6050_read(uint8_t regAddr, uint8_t *buffer, int size)
{
  int i,n, n1, n2, error;

  n1 = i2c_start(MPU6050_I2C_ADDRESS | I2C_WRITE );
  n2 = i2c_write(regAddr);
  i2c_stop();
  /*
  Serial.println (regAddr, HEX);
 Serial.print (n1);
 Serial.print ("___rd___");
 Serial.println (n2);
    */
  delay (50);
 
  
  int r = 0;
  while (r < (size - 1)){
  i2c_start(MPU6050_I2C_ADDRESS | I2C_READ);
  buffer[r] = i2c_read (false);
  i2c_stop();
  r++;
  } 
  
  i2c_start(MPU6050_I2C_ADDRESS | I2C_READ);
  buffer[r] = i2c_read (true);
  i2c_stop();
  
  
 return (0);  // return : no error
  
}

// --------------------------------------------------------
// MPU6050_read_one
//
// Function for reading one byte
// from the sensor - 
//


int MPU6050_read_one(uint8_t regAddr)
{
  int i,n, n1, n2, error, oneByte,  buffer;
//read high byte at first address
  n1 = i2c_start(MPU6050_I2C_ADDRESS | I2C_WRITE );
  n2 = i2c_write(regAddr);
  i2c_stop();
  //---troubleshooting prints--->
  /*
  Serial.println (regAddr, HEX);
  Serial.print (n1);
  Serial.print ("___rd___");
  Serial.println (n2);
    */
  i2c_start(MPU6050_I2C_ADDRESS | I2C_READ);
  oneByte = i2c_read (false); //read one byte
  i2c_stop();
  
   
 return oneByte;  // return byte value
  
}

// --------------------------------------------------------
// MPU6050_read_two
//
// Function for reading two bytes
// from the sensor - raw data is two bytes per axis
//


int MPU6050_read_two(uint8_t regAddr)
{
  int i,n, n1, n2, error, hByte, lByte, buffer;
//read high byte at first address
  n1 = i2c_start(MPU6050_I2C_ADDRESS | I2C_WRITE );
  n2 = i2c_write(regAddr);
  
  i2c_stop();
  /*
  Serial.println (regAddr, HEX);
 Serial.print (n1);
 Serial.print ("___rd___");
 Serial.println (n2);
    */
  i2c_start(MPU6050_I2C_ADDRESS | I2C_READ);
  hByte = i2c_read (false); //read high byte
  
  i2c_stop();
  regAddr++;
  
  
  //read low byte at next address
  n1 = i2c_start(MPU6050_I2C_ADDRESS | I2C_WRITE );
  n2 = i2c_write(regAddr);
  
  i2c_stop();/*
  Serial.println (regAddr, HEX);
 Serial.print (n1);
 Serial.print ("___rd___");
 Serial.println (n2);
    */
  i2c_start(MPU6050_I2C_ADDRESS | I2C_READ);
  lByte = i2c_read (true); //read low byte
  i2c_stop();
  /*
  Serial.print (hByte, BIN);
  Serial.print ("===");
  Serial.println (lByte, BIN);
  */
  hByte = hByte << 8;
  buffer = hByte | lByte;
  /*
  Serial.print (buffer);
  Serial.println (buffer, BIN);
  */
  
 return buffer;  // return 
  
}



// --------------------------------------------------------
// MPU6050_write_one
//
// test function to write one byte, int

//
int MPU6050_write_one(int regAddr, int pData)
{
  int i, n, n1, n2, error;
Serial.println ("start write");

 if(!i2c_start(MPU6050_I2C_ADDRESS | I2C_WRITE))  //Wire.beginTransmission(MPU6050_I2C_ADDRESS);
 {return false;
 }
  if(!i2c_write(regAddr))   // write the start address
  {return false;
}
if (!i2c_write(pData))
{return false;
}
  i2c_stop();
  return (3);
  
}





